#include "EditorServer.h"
#include <Zeit.h>
#include <iostream>
#include <fstream>
#include <Globals.h>
#include <sys/resource.h>

int main()
{
	struct rlimit core_limits;
	core_limits.rlim_cur = core_limits.rlim_max = RLIM_INFINITY;
	setrlimit(RLIMIT_CORE, &core_limits);
#ifdef DEBUG
    chdir( "/test/editor" );
#endif
    Framework::initFramework();
	Zeit *z = getZeit();
	Text *pfad = new Text( "../log/editor/" );
	pfad->append( z->getZeit( "y-m-d h-i-s.log" ) );
	z->release();
	DateiPfadErstellen( pfad->getThis() );
	std::ofstream file;
	file.open( pfad->getText() );
	std::streambuf* sbuf = std::cout.rdbuf();
	std::cout.rdbuf( file.rdbuf() );
	pfad->release();

	std::cout << "EdS: Startet...\n";
	std::cout << "EdS: Lese init Datei ../data/edsInit.ini ...\n";
	InitDatei *dat = new InitDatei( "../data/edsInit.ini" );
	if( !dat->laden() )
	{
		std::cout << "EdS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
		dat->release();
		exit( 1 );
    }
    if( !dat->wertExistiert( "KartenPfad" ) )
    {
        std::cout << "EdS: error: Der Wert 'KartenPfad' wurde in der Datei '../data/edsInit.ini' nicht gefunden. Das Programm wird geschlossen.\n";
        dat->release();
        exit( 1 );
    }
    const char *wichtig[] = { "ServerId", "DBBenutzer", "DBPasswort", "DBName", "DBIP", "DBPort", "Aktiv", "KartenPfad", "gslPfad", "SpielePfad", "SSLCert", "SSLKey", "SSLPasswort" };
    for( const char *w : wichtig )
    {
        if( !dat->wertExistiert( w ) )
        {
            std::cout << "EdS: error: Der Wert '" << w << "' wurde nicht gefunden. Das Programm wird geschlossen.\n";
            dat->release();
            exit( 1 );
        }
    }

	EditorServer *iServer = new EditorServer( dat );

	std::cout << "EdS: Der Admin Server läuft. Startforgang beendet.\n";
	iServer->runn();

	iServer->ende();
	iServer->release();
	dat->release();
	std::cout << "EdS: Der Server ist heruntergefahren.\n";
	file.close();
	std::cout.rdbuf( sbuf );
    Framework::releaseFramework();
	return 0;
}